// Code generated by gobind. DO NOT EDIT.

// Java class org.ethereum.geth.Enode is a proxy for talking to a Go program.
//
//   autogenerated by gobind -lang=java -javapkg=org.ethereum github.com/ethereum/go-ethereum/mobile
package org.ethereum.geth;

import go.Seq;

/**
 * Enode represents a host on the network.
 */
public final class Enode implements Seq.Proxy {
	static { Geth.touch(); }
	
	private final int refnum;
	
	@Override public final int incRefnum() {
	      Seq.incGoRef(refnum, this);
	      return refnum;
	}
	
	/**
	 * NewEnode parses a node designator.
	
	There are two basic forms of node designators
	  - incomplete nodes, which only have the public key (node ID)
	  - complete nodes, which contain the public key and IP/Port information
	
	For incomplete nodes, the designator must look like one of these
	
	   enode://&lt;hex node id&gt;
	   &lt;hex node id&gt;
	
	For complete nodes, the node ID is encoded in the username portion
	of the URL, separated from the host by an @ sign. The hostname can
	only be given as an IP address, DNS domain names are not allowed.
	The port in the host name section is the TCP listening port. If the
	TCP and UDP (discovery) ports differ, the UDP port is specified as
	query parameter &#34;discport&#34;.
	
	In the following example, the node URL describes
	a node with IP address 10.3.58.6, TCP listening port 30303
	and UDP discovery port 30301.
	
	   enode://&lt;hex node id&gt;@10.3.58.6:30303?discport=30301
	 */
	public Enode(String rawurl) {
		this.refnum = __NewEnode(rawurl);
		Seq.trackGoRef(refnum, this);
	}
	
	private static native int __NewEnode(String rawurl);
	
	Enode(int refnum) { this.refnum = refnum; Seq.trackGoRef(refnum, this); }
	
	@Override public boolean equals(Object o) {
		if (o == null || !(o instanceof Enode)) {
		    return false;
		}
		Enode that = (Enode)o;
		return true;
	}
	
	@Override public int hashCode() {
	    return java.util.Arrays.hashCode(new Object[] {});
	}
	
	@Override public String toString() {
		StringBuilder b = new StringBuilder();
		b.append("Enode").append("{");
		return b.append("}").toString();
	}
}

